;-------------------------------------------------------------------------------
; MSP430 Assembler Code Template for use with TI Code Composer Studio
;
;
;-------------------------------------------------------------------------------
            .cdecls C,LIST,"msp430.h"       ; Include device header file

;-------------------------------------------------------------------------------
            .text                           ; Assemble into program memory
            .retain                         ; Override ELF conditional linking
                                            ; and retain current section
            .retainrefs                     ; Additionally retain any sections
                                            ; that have references to current
                                            ; section
;-------------------------------------------------------------------------------
RESET       mov.w   #__STACK_END,SP         ; Initialize stackpointer
StopWDT     mov.w   #WDTPW|WDTHOLD,&WDTCTL  ; Stop watchdog timer

;-------------------------------------------------------------------------------
                                            ; Main loop here

; Z-bit (Zero Status Bit)

        	mov.w	#0x0003,  R10
        	mov.w	#0x0003,  R11
        	sub.w   R10, R11				; status bit Z set

        	mov.w	#0x0001,  R10
        	mov.w	#0x0003,  R11
        	sub.w   R10, R11				; status bit Z reset (cleared)

; N-bit  (Negative Status Bit)

        	mov.w	#0x0004,  R10
        	mov.w	#0x0002,  R11
        	sub.w   R10, R11				; status bit N set

        	mov.w	#-4,  R10
        	mov.w	#-0x0008,  R11
        	add.w   R10, R11				; status bit N set

        	mov.w	#-4,  R10
        	mov.w	#0x0008,  R11
        	add.w   R10, R11				; status bit N reset (cleared)

        	mov.w	#2,  R10
        	mov.w	#2,  R11
        	add.w   R10, R11				; status bit N reset (cleared)

; C-bit  (Carry Status Bit)

        	mov.b	#11000001b,  R10
        	mov.b	#11000001b,  R11
        	add.b   R10, R11				; status bit C set

        	mov.b	#10000001b,  R10
        	mov.b	#10000001b,  R11
        	add.b   R10, R11				; status bit C set

            mov.b	#11111110b,  R10		; R10 contains -2
        	mov.b	#11000000b,  R11		; R11 contains -64
        	sub.b   R10, R11				;-64-(-2) = -62 no carry, status bit C reset

 ; V-bit  (Overflow Status Bit)

        	mov.b	#11000001b,  R10
        	mov.b	#11000001b,  R11
        	add.b   R10, R11				; status bit V cleared

        	mov.b	#10000001b,  R10
        	mov.b	#10000001b,  R11
        	add.b   R10, R11				; status bit V set


loop:		jmp loop
;-------------------------------------------------------------------------------


;-------------------------------------------------------------------------------
;           Stack Pointer definition
;-------------------------------------------------------------------------------
            .global __STACK_END
            .sect 	.stack

;-------------------------------------------------------------------------------
;           Interrupt Vectors
;-------------------------------------------------------------------------------
            .sect   ".reset"                ; MSP430 RESET Vector
            .short  RESET
